package net.locusworks.lsproject.gui;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import net.locusworks.lsproject.gui.helper.ImageHelper;

/**
 * The DebugConsole displays normal debug messages from stdout.
 */
public class DebugConsole extends JFrame {
	private static final long serialVersionUID = -4430646440883436819L;
	private JTextArea textArea;
	
	public DebugConsole() {
		super("Debug Console");
		
		textArea = new JTextArea();
		setSize(400, 300);
		textArea.setSize(400, 300);
		textArea.setEditable(false);
		textArea.setLineWrap(true);
		
		JScrollPane pane = new JScrollPane(textArea);
		pane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		pane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		
		setIconImage(ImageHelper.getImageFromResource("assets/router_ico.png"));
		
		add(pane);
		
		setVisible(true);
	}
	
	/**
	 * Write a normal string to the console.
	 * @param s String to write.
	 */
	public void writeString(String s) {
		textArea.append(s);
		textArea.setCaretPosition(textArea.getText().length());
	}
	
	/**
	 * Write an error string to the console.
	 * @param s String to write.
	 */
	public void writeError(String s) {
		textArea.append(s);
		textArea.setCaretPosition(textArea.getText().length());
	}
}
