package object;

import static org.junit.Assert.*;

import java.awt.Point;

import org.junit.Before;
import org.junit.Test;

import net.locusworks.lsproject.object.Connection;
import net.locusworks.lsproject.object.Router;

public class RouterTest {
	private Router router = null;
	
	
	@Before
	public void setUpBeforeTest(){
		
		router = new Router("192.168.1.0", new Point(0, 0));	
		
		
	}
	
	@Test
	public void testGetIpAddress() {
		if (! router.getIpAddress().equals("192.168.1.0")){
			fail("ip Address does not match");
		}
	}

	@Test
	public void testSetIpAddress() {
		router.setIpAddress("192.168.1.2");
		if(! router.getIpAddress().equals("192.168.1.2")){
			fail("Ip address did not set correctly");
		}
		
	}

	@Test
	public void testAddConnection() {
		Connection testConnection = new Connection("192.168.1.3", "192.168.1.4", 3);
		router.addConnection(testConnection);
		
		String connection1 = router.getConnections().get(0).getFirstParticipantAddress();
		String connection2 = router.getConnections().get(0).getSecondParticipantAddress();
		
		assertEquals("192.168.1.3", connection1);
		assertEquals("192.168.1.4", connection2);

	}

	@Test
	public void testGetConnectionByParticipant() {
		
		for(int i = 0; i < 10; i++){
			router.addConnection(new Connection(Integer.toString(i), Integer.toString(i+1), 1));
		}
		
		
		for (int i = 0; i < 10; i++){
			Connection testConnection = router.getConnectionByParticipant(
					Integer.toString(i), Integer.toString(i+1));
			assertEquals(Integer.toString(i), testConnection.getFirstParticipantAddress());
			assertEquals(Integer.toString(i+1), testConnection.getSecondParticipantAddress());
		}
		
		Connection testCase = new Connection ("a", "A", 1);
		
		router.clearConnections();
		
		router.addConnection(testCase);
		assertNull(router.getConnectionByParticipant("a", "a"));
	
	}

}
